#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#include"hash.c"
#include"prime.c"

struct shptr ptr;
syn_t *base;
char str[256];
struct element {
    unsigned key;
    char *str;
}*file;
int len,count;

int filematch(void *telement) {
        struct element *rec = (struct element *)telement;
        return strcmp(rec->str,file->str);
    }

void freee(void *ptr) {
      free(((struct element *)ptr)->str);
      free((struct element *)ptr);
     }

int main() {
      base = shnew(1000);
      count = 0;
      while(! feof(stdin)) {
            scanf("%s",str);
            file = malloc(sizeof(struct element));
            if(! file) break;
            len = strlen(str);
            file->str = malloc(len + 1);
            if(! file->str) break;
            strcpy(file->str,str);
            file->key = strsign(file->str);
            shadd(base,1000,file->key,(void *)file);
            count++;
      }
      printf("%d elements added\nListing them now",count);
      shseek(base,1000,&ptr,SHSEEK_FIRST);
      do {
          struct element *rec = (struct element *)((ptr.curr)->element);
          printf("\n%s",rec->str);
      } while( shseek(base,1000,&ptr,SHSEEK_NEXT) );
      shdispose(base,1000,freee);
      return 0;
    }
